/* complex_math.h   include file for complex math calls
Ken Stephenson, 8/91 */

#ifndef __COMPLEX_MATH_PROTO_H__
#define __COMPLEX_MATH_PROTO_H__

extern double cAbs(complex);
extern double Arg(complex);
extern double inv_dist(complex,double,complex,double);
extern double EpsMach(void);
extern complex cadd(complex,complex);
extern complex cmult(complex,complex);
extern complex cdiv(complex,complex);
extern complex csub(complex,complex);
extern complex cconj(complex);
extern complex csqrt(complex z);
extern complex cExp(double,double);
extern complex cLog(complex);
extern complex mob_trans(complex,complex);
extern complex mob_norm(complex,complex,complex);
extern complex mob_norm_inv(complex,complex,complex);
extern complex mob_rotate(complex,double);
extern complex mobius(Mobius,complex,int);
extern complex det(Mobius);
extern Mobius matrix_product(Mobius,Mobius);
extern Mobius mult_mobius(Mobius,Mobius,int);
extern Mobius zero_inf(complex,complex,double,double,double );
extern Mobius disc_match_mob(complex z1, complex z2, complex w1, complex w2);
extern complex tsqr_mob(complex Mobius_M);
extern Mobius emap_mob(complex z1,complex z2,complex w1,complex w2);
extern Mobius ident_mob();
extern Mobius inv_mob(Mobius);
extern Mobius standard_mob(complex,complex,int*);
extern Mobius auto_abAB(complex,complex,complex,complex,double*,int*);

#endif
