#include "sa_types.h"

struct p_data *pack_data;
struct s_data *screendata;

/* =================================================================
Global variables: here because often required by library routines. */

FILE *fp;
char buff[BUFSIZE],cmd[2*BUFSIZE],data[2*BUFSIZE],next[BUFSIZE];
char buf[BUFSIZE];  /* general purpose utility buffer */
int alist[300];
int dum_int;
int javaMsgHook;
struct p_data *packdata;
double toler;	/* numerical tolerance for computing */
double okerr;	/* quantity small enough to set to zero 
		   in calculating */
double m_toler; /* machine tolerence = sqrt(machine precision) */
unsigned long fgcolor,bgcolor; /* indices of fore/backgound colors */
int sc_print_size;	/* size (inches) for postscript output */
int color_ramp_size;    /* color ramp depends on GUI being used */
unsigned char red[NUM_COLORS+1],green[NUM_COLORS+1],blue[NUM_COLORS+1];
int bc_min,bc_max;        /* min/max indices for special colors
			     (those for which bdry color is modified
			     from those of interior) */
int bc_offset;            /* When reading color values from rgb_file,
			     store circle/face bdry colors values 
			     at .75 of parent (interior); store 
			     in color map with offset (<0) to 
			     index of parent value. */
int line_thick;		/* thickness setting for lines */
double ps_linewidth;    /* linewidth for postscript */
double graylevel;       /* double value to send to postscript */
int fill_mode;		/* mode for filled objects: 0=grey,1=white,
				   2=black */
Box std_real_box;	/* default real world window */
int iterates;		/* number Newton iterates in pack computations */
unsigned long int rand_next; /* random number generator variable */
int num_plot;		/* num plot points for arcs on sphere */
double degPI;           /* set to 180.0/M_PI */

struct Vertlist *Vlist;   /* global utility vert list */
struct Vertlist *Flist;   /* global utility face list */
struct Edgelist *Elist;   /* global utility edge list */
struct Edgelist *Vertex_map;/* global utility vertex_map */
struct Centlist *Clist;   /* globel utility center list */

struct Pathlist *pathlist,*newpath; 	
			  /* specify "cookie cutting" paths. */
int pathlength;		  /* number of pts in stored pathlist */
CPRegion region;            /* for XLib region info */

int **face_org;           /* For short-lived data on face indices
			     needed by several routines. */
double layout_th;         /* layout threshold: tolerance for placement
			     errors in pack centers. */

extern struct Vertlist *Node_link_parse(),*Face_link_parse();
extern struct Edgelist *Node_pair_link();

struct remote_control remote[NUM_PROC];
struct remote_control my_remote[NUM_PROC];
