/* Martin.cpp   Routines for Martin Seehafer */
#include "sa_head.h"
#include "sa_types.h"
#include "sa_proto.h"

/* ==========Must update this menu when routines change=============== */

int Martin(char *datastr)
{
  int pnum,mnum,hits,v,wflag=0,count=0;
  double t=1.0,rat;
  char next[20],*endptr;
  struct p_data *p=NULL,*m=NULL;
  struct Vertlist *vertlist=NULL,*trace;

  if (sscanf(datastr,"%d %d %lf",&pnum,&mnum,&t)!=3 ||
      pnum<0 || mnum<0 ||
      pnum> NUM_PACKS || mnum>NUM_PACKS) {
    sprintf(msgbuf,"Martin: must give p0 (Omega), p1 (Max pack), and "
	    "adjustment parameter t");
    emsg();
    return 0;
  }
  p=&packdata[pnum];
  m=&packdata[mnum];
  if (!p->status || !m->status || p->hes || m->hes
      || p->nodecount!=m->nodecount) {
    sprintf(msgbuf,"Martin: must give two eucl.packings for Omega and "
	    "for its max packing (but euclidean)");
    emsg();
    return 0;
  }
  /* get the prescribed parameter t */
  strcpy(next,"b");
  if (!(vertlist=node_link_parse(p,next,&endptr,&hits))) {
    sprintf(msgbuf,"Martin: error getting bdry vertlist");
    emsg();
  }

  trace=vertlist;
  while (trace!=NULL) {
    rat=m->packR_ptr[(v=trace->v)].rad/p->packR_ptr[v].rad;
    p->packR_ptr[trace->v].rad *= (1+t*rat);
    trace=trace->next;
    count++;
  }
  return count;
} /* Martin */


  
  


