#include "sa_types.h"
#include "sa_proto.h"

/* called only by 'add_barys' and 'bary_refine'; put trivalent 
vert in face f; data not updated between calls, so face data remains
valid. */

int add_barycenter(struct p_data *p,int f)
{
  int i,j,v,w,newval,indx,*newflower;
  double *newol;
  struct K_data *pK_ptr;
  struct R_data *pR_ptr;
	
  pK_ptr=p->packK_ptr;pR_ptr=p->packR_ptr;
  /* add new vertex */
  newval=p->nodecount+1;
  p->nodecount++;
  pK_ptr[newval].num=3;
  pK_ptr[newval].flower=(int *)calloc((size_t)4,sizeof(int));
  pK_ptr[newval].flower[0]=pK_ptr[newval].flower[3]=p->faces[f].vert[0];
  pK_ptr[newval].flower[1]=p->faces[f].vert[1];
  pK_ptr[newval].flower[2]=p->faces[f].vert[2];
  if (p->overlap_status)
    {
      pK_ptr[newval].overlaps=(double *)calloc((size_t)4,sizeof(double));
      pK_ptr[newval].overlaps[0]=pK_ptr[newval].overlaps[1]
	=pK_ptr[newval].overlaps[2]=pK_ptr[newval].overlaps[3]=1.0;
    }
  pK_ptr[newval].bdry_flag=0;
  pK_ptr[newval].mark=0;
  pK_ptr[newval].color=FG_COLOR;
  pR_ptr[newval].rad=pR_ptr[p->faces[f].vert[0]].rad;
  pR_ptr[newval].aim=2.0*M_PI;
  /* compute packed radius */
  if (p->hes<0) h_riffle_vert(p,newval);
  else if (p->hes>0) s_riffle_vert(p,newval);
  else e_riffle_vert(p,newval);
  if (p->hes<=0)
    {
      pR_ptr[newval].center.re=
	(pR_ptr[p->faces[f].vert[0]].center.re
	 +pR_ptr[p->faces[f].vert[1]].center.re
	 +pR_ptr[p->faces[f].vert[2]].center.re)/3.0;
      pR_ptr[newval].center.im=
	(pR_ptr[p->faces[f].vert[0]].center.im
	 +pR_ptr[p->faces[f].vert[1]].center.im
	 +pR_ptr[p->faces[f].vert[2]].center.im)/3.0;
    }
  else {pR_ptr[newval].center.re=0.0;pR_ptr[newval].center.re=M_PI;}
  /* adjust nghb flowers */
  for (i=0;i<3;i++)
    {
      v=p->faces[f].vert[i];
      w=p->faces[f].vert[(i+1)%3];
      indx=nghb(p,v,w);
      newflower=(int *)calloc((size_t)(pK_ptr[v].num+2),
			      sizeof(int));
      for (j=0;j<=indx;j++) newflower[j]=pK_ptr[v].flower[j];
      for (j=pK_ptr[v].num;j>indx;j--)
	newflower[j+1]=pK_ptr[v].flower[j];
      newflower[indx+1]=newval;
      free(pK_ptr[v].flower);
      pK_ptr[v].flower=newflower;
      if (p->overlap_status)
	{
	  newol=(double *)calloc((size_t)(pK_ptr[v].num+2),sizeof(double));
	  for (j=0;j<=indx;j++) newol[j]=pK_ptr[v].overlaps[j];
	  for (j=pK_ptr[v].num;j>indx;j--)
	    newol[j+1]=pK_ptr[v].overlaps[j];
	  newol[indx+1]=1.0;
	  free(pK_ptr[v].overlaps);
	  pK_ptr[v].overlaps=newol;
	}
      pK_ptr[v].num++;
    }
  return 1;
} /* add_barycenter */
