#include "sa_types.h"
#include "sa_proto.h"

/**
 * adds a vertex which connects up to all vertices on the boundary
 * component of vertices in given list.
 */
int add_ideal(struct p_data *p,struct Vertlist *vertlist)
{
  int count=0;
  struct Vertlist *trace;

  if (!vertlist) return 0; /* no vertices given */
  trace=vertlist;
  while(trace && p->packK_ptr[trace->v].bdry_flag)
    {
      count += ideal_bdry_node(p,trace->v);
      trace=trace->next;
    }
  if (!count) return 0;
  choose_alpha(p);
  if (p->xyzpoint) {free(p->xyzpoint);p->xyzpoint=NULL;}
  complex_count(p,0);
  facedraworder(p,0);
  return count;
} /* add_ideal */

/**
 * add ideal vertex to every bdry component (default)
 * or to the components containing the given vertices.
 * Return the count of ideal vertices or 0 on error.
 */
int add_ideal_call(struct p_data *p,char *datastr)
{
  int v,hits,i;
  char *endptr,*nextptr=datastr;
  struct Vertlist *vlist=NULL,*trace;
  
  if (p->num_bdry_comp==0) {
  	sprintf(msgbuf,"'add_ideal' failed: the packing has no boundary");
  	emsg();
  	return 0;
  }
  stripsp(nextptr);
  if (strlen(nextptr)==0) { // default to all bdry components; make a list
  	vlist=trace=(struct Vertlist *)calloc(1,sizeof(struct Vertlist));
  	for (i=1;i<=p->num_bdry_comp;i++) {
  		trace=trace->next=(struct Vertlist *)calloc(1,sizeof(struct Vertlist));
  		trace->v=p->bdry_starts[i];
  	}
  	trace=vlist;
  	vlist=vlist->next;
  	free(trace);
  }
  else if (!(vlist=Node_link_parse(p,datastr,&endptr,&hits,
  		&Vlist,&Elist,&Flist,&region,pathlist,pathlength))) return 0;
  int ans=add_ideal(p,vlist);
  vert_free(&vlist);
  return ans;
} /* add_ideal_call */

