#include "sa_types.h"
#include "sa_proto.h"

/* given an edge_pair index, apply corresponding mobius 
transform to the packing. */

int apply_pair_mobius(struct p_data *p,char *datastr)
{
  int flag=1,n=0;
  char *nextptr,next[128];
  Mobius Mob;

  nextptr=datastr;
  if (!p->redfaces) return 0; /* no edge pairing */
  if (!grab_next(&nextptr,next)) n=1; /* default to first pairing */
  else if (!strcmp(next,"-1")) /* inverse mapping */
    {
      flag=-1;
      if (!grab_next(&nextptr,next)) n=1;
    }
  if ((n && !p->edge_pair[n].mate) || (!sscanf(next,"%d",&n)
      || n<1 || n>3*MAX_COMPONENTS || !p->edge_pair[n].edge))
    return 0; /* no edge pairing */
  Mob=p->edge_pair[n].mob;
  apply_Mobius(p,"a",flag,Mob);
  return 1;
} /* apply_pair_mobius */


