#include "sa_types.h"
#include "sa_proto.h"

/* Calls to get quasiconformal dilatations of maps between
   circle packing faces. */
/* fixup: only have eucl computations so far. */

int face_dilatation(struct p_data *p,struct p_data *q,
		    int face,double *retval)
     /* Assume face is face common to p and q. Ultimately should handle
any geometries, but currently only euclidean. Return 0 on error. */
{
  double r1,r2,r3,A,B,C,a,b,c;

  *retval=1.0;
  if (!p->hes && !q->hes) /* both eucl */
    {
      r1=p->packR_ptr[p->faces[face].vert[0]].rad;
      r2=p->packR_ptr[p->faces[face].vert[1]].rad;
      r3=p->packR_ptr[p->faces[face].vert[2]].rad;
      A=r1+r2;B=r2+r3;C=r3+r1;
      r1=q->packR_ptr[q->faces[face].vert[0]].rad;
      r2=q->packR_ptr[q->faces[face].vert[1]].rad;
      r3=q->packR_ptr[q->faces[face].vert[2]].rad;
      a=r1+r2;b=r2+r3;c=r3+r1;
      if (!e_dilatation(A,B,C,a,b,c,retval)) return 0;
    }
  else return 0; /* only eucl for now. */
  return 1;
} /* face_dilatation */
