#include "sa_types.h"
#include "sa_proto.h"

/* Decompositions of packings (e.g., for use with parallel
algorithms) can be stored in *.vl files, which have the following
input file format (at least for developmental purposes):
("[..]" data was introduced for overlaps with mpi runs.)

   CHECK_COUNT: {nodecount of parent}
   VERT_LIST_COUNT: n (limit n=200. optional: else read up to 200 lists.)

   PARENT: {parent packing}

   [NUM_GENERATIONS: {num_generations}] (for adding overlap buffers)

   VERT_LIST: {list-1} (done)
   [WEIGHT_LIST: {weight_list-1} (done)] (depth of verts from bdry)
   ..
   ..
   VERT_LIST: {list-n} (done)
   [WEIGHT_LIST: {weight_list-n} (done)]

Assume output file fp is already open for writing. This routine
saves the initial information; vertex lists can then be added
with 'write_vert_list'. */

int create_parent(struct p_data *p,FILE *fp,int N)
{
  fprintf(fp,"CHECK_COUNT: %d\nVERT_LIST_COUNT: %d\n\nPARENT:\n",
	  p->nodecount,N);
  return(writepack(fp,p,00037,0));
} /* create_parent */
