#include "sa_types.h"
#include "sa_proto.h"

int gen_islands(struct p_data *p,int seed, char *datastr)
     /* Create new packing by replacing each component of vertices
not in datastr description by a single circle -- like "plug" 
idea. Seed vert determines the remaining complex.
Return 0 on error, else new nodecount. Set up vertex_map to original
indices. */
{
  int *newold=NULL,i,j,w,num,firstcount,vert,hits;
  char *endptr;
  struct Edgelist *trace;
  struct Vertlist *vlist=NULL,*vtrace;
  extern char buf[1024];

  vert=p->bdry_starts[1]; /* hold this bdry vert for later use */
  /* mark which vertices are to be removed */
  if (!(vlist=Node_link_parse(p,datastr,&endptr,&hits,
		 &Vlist,&Elist,&Flist,&region,pathlist,pathlength)))
    return 0;
  for (i=1;i<=p->nodecount;i++) p->packK_ptr[i].mark=0;
  vtrace=vlist;
  while (vtrace) {
    p->packK_ptr[vtrace->v].mark=1;
    vtrace=vtrace->next;
  }
  vert_free(&vlist);
  
  sprintf(buf,"-v %d m",seed);
  if (!(firstcount=cookie_cutter(p,buf,&newold))) {
    if (newold) free(newold);
    return 0;
  }
  for (i=1;i<=firstcount;i++) { /* find new vertex number for 'vert' */
    if (newold[i]==vert) {
      vert=i;
      i=firstcount+1; /* to break loop */
    }
  }
  if (newold) { /* set up vertex_map */
    p->vertex_map=trace=(struct Edgelist *)
      calloc((size_t)1,sizeof(struct Edgelist));
    for (j=1;j<=p->nodecount;j++)
      if ((w=newold[j])) {
	trace=trace->next=(struct Edgelist *)
	  calloc((size_t)1,sizeof(struct Edgelist));
	trace->v=j;
	trace->w=w;
      }
    trace=p->vertex_map;
    p->vertex_map=p->vertex_map->next;
    free(trace);
  }
  for (i=1;i<=firstcount;i++)
    if (p->packK_ptr[i].bdry_flag) {
      vlist=(struct Vertlist *)calloc((size_t)1,sizeof(struct Vertlist));
      vlist->v=i;
      if (!add_ideal(p,vlist)) {
	vert_free(&vlist);
	return 0;
      }
      vert_free(&vlist);
    }
  num=p->packK_ptr[vert].num;
  for (j=0;j<num;j++)
    if ((w=p->packK_ptr[vert].flower[j])>firstcount) {
      puncture(p,w);
      complex_count(p,0);
      facedraworder(p,0);
      j=num; /* to break out of loop */
    }
  return p->nodecount;
} /* gen_islands */
	



