#include "sa_types.h"
#include "sa_proto.h"

/* returns best radius at vert i to get anglesum aim, via secant 
method. x = first guess.  */

extern int iterates;

double h_radcalc(struct p_data *p,int i,double x,double aim,int *chgflag)
{
  int n,flag;
  double bestcurv,lower=0.5,upper=0.5,upcurv,lowcurv,factor=0.5;

  h_anglesum_overlap(p,i,x,&bestcurv,&flag);
  if (bestcurv>(aim+okerr))
    {
      lower=1-factor+x*factor;
      h_anglesum_overlap(p,i,lower,&lowcurv,&flag);
      (*chgflag)++;
      if (lowcurv>aim) return lower;
    }
  else if (bestcurv<(aim-okerr))
    {
      upper=x*factor;
      h_anglesum_overlap(p,i,upper,&upcurv,&flag);
      (*chgflag)++;
      if (upcurv<aim) return upper;
    }
  else return x;
  (*chgflag)++;
  for (n=1;n<=iterates;n++)
    {
      if (bestcurv>(aim+okerr)) 
	{
	  upper=x;
	  upcurv=bestcurv;
	  x -= (bestcurv-aim)*(lower-x)/(lowcurv-bestcurv);
	}
      else if (bestcurv<(aim-okerr))
	{
	  lower=x;
	  lowcurv=bestcurv;
	  x += (aim-bestcurv)*(upper-x)/(upcurv-bestcurv);
	}
      else return x;
      h_anglesum_overlap(p,i,x,&bestcurv,&flag);
    }
  return x;
} /* h_radcalc */
