#include "sa_types.h"
#include "sa_proto.h"

/* shell_main.c is a TEMPLATE for writing stand-alone code which
uses the "circle packing" library. 'cp_types.h' declares certain
extern routines, global variables, and message space which 
certain library routines will expect to be in place. This file
does the minimum necessary; portions can be changed if the
objects are to be used in more refined ways. */

char *emsgbuf,*msgbuf;
int repack_activity_msg(),refresh_canvas();

int main(int argc,char *argv[])
{
  int i;
  double ang;
  FILE *fp;
  set_CPack_globals();

  /* ----------- user code starts here */

  fp=fopen("unit_circle.g","w");
  fprintf(fp,"PATH\n");
  for (i=0;i<=1000;i++)
    {
      ang=(float)(2.0*M_PI*i/1000);
      fprintf(fp,"%.12f %.12f\n",cos(ang),sin(ang));
    }
  fprintf(fp,"END\n");
  fclose(fp);
  
/* ----------- user code ends here */
  exit(0);
} /* main */


/* ====== communication routines; user may want to modify ====== */

int emsg()
{
  printf(emsgbuf);return 1;
} /* emsg */

int msg()
{
  printf(msgbuf);return 1;
} /* msg */

int repack_activity_msg(char *datastr)
     /* report progress of repacking */
{
  strcpy(msgbuf,datastr);
  msg();
  return 1;
} /* repack_activity_msg */

int refresh_canvas(struct s_data *q)
     /* some drawing routines want to refresh */
{return 1;} /* refresh_canvas */

/* ================================================================= */

