#include "sa_types.h"
#include "sa_proto.h"

/* from bdry v to ngb interior w, open edge. 0 for
failure. */

int open_edge(struct p_data *p,int v,int w)
{
  int newval,ind,back,k,u,*newflower;
  double *newoverlaps;
  struct K_data *pK_ptr;
  struct R_data *pR_ptr;

  if (v<0 || v>p->nodecount || !p->packK_ptr[v].bdry_flag 
      || (ind=nghb(p,v,w))<0 || p->packK_ptr[w].bdry_flag)
    return 0;
  /* new vert */
  newval=p->nodecount+1;
  if ( (p->nodecount+1) > (p->sizelimit)
       && !alloc_pack_space(p,newval,1) )
    {
      sprintf(msgbuf,
	      "Space allocation problem with adding vertex.");
      emsg();
      return 0;
    }
  pK_ptr=p->packK_ptr;
  pR_ptr=p->packR_ptr;
  pK_ptr[newval].num=pK_ptr[v].num-ind;
  pK_ptr[newval].flower=(int *)calloc((size_t)(pK_ptr[newval].num+1),
				   sizeof(int));
  for (k=0;k<=pK_ptr[newval].num;k++)
    pK_ptr[newval].flower[k]=pK_ptr[v].flower[k+ind];
  if (p->overlap_status) 
    {
      pK_ptr[newval].overlaps=(double *)
	calloc((size_t)(pK_ptr[newval].num+1),sizeof(double));
      for (k=0;k<=pK_ptr[newval].num;k++)
	pK_ptr[newval].overlaps[k]=pK_ptr[v].overlaps[k+ind];
    }
  else pK_ptr[newval].overlaps=NULL;
  pK_ptr[newval].bdry_flag=1;
  pR_ptr[newval].aim=-1.0;
  pR_ptr[newval].rad=pR_ptr[v].rad;
  pR_ptr[newval].center=pR_ptr[v].center;
  /* fix its ngb's flowers */
  for (k=1;k<=pK_ptr[newval].num;k++)
    {
      back=nghb(p,(u=pK_ptr[v].flower[k+ind]),v);
      pK_ptr[u].flower[back]=newval;
      if (!back && !pK_ptr[u].bdry_flag)
	pK_ptr[u].flower[pK_ptr[u].num]=newval;
    }
  /* fix v's flower */
  newflower=(int *)calloc((size_t)(ind+1),sizeof(int));
  for (k=0;k<=ind;k++) newflower[k]=pK_ptr[v].flower[k];
  free(pK_ptr[v].flower);
  pK_ptr[v].flower=newflower;
  if (pK_ptr[v].overlaps) 
    {
      newoverlaps=(double *)calloc((size_t)(ind+1),sizeof(double));
      for (k=0;k<=ind;k++)
	newoverlaps[k]=pK_ptr[v].overlaps[k];
      free(pK_ptr[v].overlaps);
      pK_ptr[v].overlaps=newoverlaps;
    }
  pK_ptr[v].num=ind;
  /* fix w */
  back=nghb(p,w,v);
  newflower=(int *)calloc((size_t)(pK_ptr[w].num+1),sizeof(int));
  for (k=0;k<pK_ptr[w].num;k++)
    newflower[k]=pK_ptr[w].flower[(k+back) % pK_ptr[w].num];
  newflower[pK_ptr[w].num]=newval;
  free(pK_ptr[w].flower);
  pK_ptr[w].flower=newflower;
  if (pK_ptr[w].overlaps)
    {
      newoverlaps=(double *)calloc((size_t)(pK_ptr[w].num+1),
				   sizeof(double));
      for (k=0;k<pK_ptr[w].num;k++)
	newoverlaps[k]=pK_ptr[w].overlaps[(k+back) % pK_ptr[w].num];
      newoverlaps[pK_ptr[w].num]=pK_ptr[w].overlaps[back];
      free(pK_ptr[w].overlaps);
      pK_ptr[w].overlaps=newoverlaps;
    }
  pK_ptr[w].bdry_flag=1;
  pR_ptr[w].aim=-1.0;
  p->nodecount++;
  return 1;
} /* open_edge */
