#include "sa_types.h"
#include "sa_proto.h"

/* list faces along given path. Pass (possible) start and ending node. 
 * Note: sphere not yet covered. */

struct Vertlist *parse_facepath(struct p_data *p,struct Pathlist *path,
				int *livenode)
{
	int flag,k;
	complex ctr[3],pt,normpt;
	double dum,det;
	struct Vertlist *thelist=NULL,*trace=NULL,*nodelist;
	struct R_data *pR_ptr;

	pR_ptr=p->packR_ptr;
	if(path==NULL) return NULL;
	pt.re=path->x;pt.im=path->y;
	if (*livenode<1 || *livenode>p->facecount 
	   || !pt_in_tri(p,*livenode,pt)) 
		*livenode=0;
	if (*livenode) {
		trace=thelist=(struct Vertlist *)calloc(1,sizeof(struct Vertlist));
		trace->v=*livenode;
	}
	else {
		while (path!=NULL && thelist==NULL) {
		if ( (nodelist=tri_search(p,pt))) {
			trace=thelist=(struct Vertlist *)
			   calloc(1,sizeof(struct Vertlist));
			trace->v=*livenode=nodelist->v;
			vert_free(&nodelist);
		}
		path=path->next;
		}
	}
	if (path==NULL) return thelist;
	while (path!=NULL) {
		for (k=0;k<=2;k++) {
		   if (p->hes<0) 
			h_to_e_data(pR_ptr[p->faces[*livenode].vert[k]].
	   	           center,pR_ptr[p->faces[*livenode].vert[k]].rad,
		           &ctr[k],&dum);
		   else ctr[k]=pR_ptr[p->faces[*livenode].vert[k]].center;
		}
		if ((ctr[0].re*(ctr[1].im-ctr[2].im)
		   -ctr[1].re*(ctr[0].im-ctr[2].im)
		   +ctr[2].re*(ctr[0].im-ctr[1].im))>0) det=1.0;
		else det=-1.0;
		while (path!=NULL 
		   && (det*row_col(path->x,path->y,
			ctr[1].re,ctr[2].re,ctr[1].im,ctr[2].im))>0
	   	   && (det*row_col(path->x,path->y,
			ctr[2].re,ctr[0].re,ctr[2].im,ctr[0].im))>0
	   	   && (det*row_col(path->x,path->y,
			ctr[0].re,ctr[1].re,ctr[0].im,ctr[1].im))>0 )
			path=path->next;
		flag=0;
		while (path!=NULL && !flag) {
			pt.re=path->x;pt.im=path->y;
			if ( (nodelist=tri_search(p,pt))!=NULL 
				&& nodelist->v!=*livenode ) {
				trace->next=(struct Vertlist *)calloc(1,sizeof(struct Vertlist));
				trace=trace->next;
				trace->v=*livenode=nodelist->v;
				vert_free(&nodelist);
				flag=1;
			}
			path=path->next;
		}
	}
	return thelist;
} /* parse_facepath */


