#include "sa_types.h"
#include "sa_proto.h"

/* Apply a Mobius transformation to modify the points of a path. 
If flag < 0 apply inverse of mob. Return 0 on error. */

int path_Mobius(Mobius mob,struct Pathlist *plist,int flag)
{
  struct Pathlist *ptrace;
  complex z,w;

  if (!(ptrace=plist)) return 0;
  while (ptrace)
    {
      z.re=ptrace->x;z.im=ptrace->y;
      w=mobius(mob,z,flag);
      ptrace->x=w.re;ptrace->y=w.im;
      ptrace=ptrace->next;
    }
  return 1;
} /* path_Mobius */
