#include "sa_types.h"
#include "sa_proto.h"

/* Two conversion routines: path to elist and vice-versa. */

struct Edgelist *path_to_elist(struct p_data *p,struct Pathlist *path_list)
{
  int hits,len=0;
  char *endptr;
  struct Vertlist *vertlist=NULL;
  struct Edgelist *E_list=NULL;
  struct Pathlist *ptrace;

  sprintf(buf,"g");
  if (!p->status || !path_list) return 0;
  ptrace=path_list;
  while(ptrace) {
    len++;
    ptrace=ptrace->next;
  }
  if (!(vertlist=Node_link_parse(p,buf,&endptr,&hits,
	&Vlist,&Elist,&Flist,&region,path_list,len))
      || hits<1) {
    vert_free(&vertlist);
    return 0;
  }
  E_list=encircle(p,vertlist,0,&hits,0);
  vert_free(&vertlist);
  return E_list;
} /* path_to_elist */

struct Pathlist *elist_to_path(struct p_data *p,
			       struct Edgelist *e_list,int *len)
{
  int w=0;
  struct Edgelist *etrace;
  struct Pathlist *ptrace,*path_list=NULL;
  struct R_data *pR_ptr=p->packR_ptr;

  *len=0;
  if (!p->status || !e_list) return 0;
  etrace=e_list;
  path_list=ptrace=(struct Pathlist *)
    calloc(1,sizeof(struct Pathlist));
  ptrace=ptrace->next=(struct Pathlist *)
    calloc(1,sizeof(struct Pathlist));
  ptrace->x=pR_ptr[etrace->v].center.re;
  ptrace->y=pR_ptr[etrace->v].center.im;
  w=etrace->w;
  (*len)++;
  while (etrace) {
    ptrace=ptrace->next=(struct Pathlist *)
      calloc(1,sizeof(struct Pathlist));
    w=etrace->w;
    ptrace->x=pR_ptr[w].center.re;
    ptrace->y=pR_ptr[w].center.im;
    (*len)++;
    etrace=etrace->next;
  }
  if (w!=e_list->v) { /* didn't close up, so close up path */
    ptrace=ptrace->next=(struct Pathlist *)
      calloc(1,sizeof(struct Pathlist));
    ptrace->x=path_list->x;
    ptrace->y=path_list->y;
    (*len)++;
  }
  ptrace=path_list; /* first position not used */
  path_list=path_list->next;
  free(ptrace);
  if((*len)>3) return path_list;
  path_free(&path_list);
  return NULL;
} /* elist_to_path */
