#include "sa_types.h"
#include "sa_proto.h"

/*
 * ps_to_jpg: does what it says by calling the UNIX shell
 * command convert.  Returns 0 on success, -1
 * for internal errors, and the shell error code for errors
 * in the command.
 */

int ps_to_jpg(const char *filename, int quality)

{
  int rv;
  char *newname,*lastdot,*cmdstr;
  char cmdtmpl[]=
    "convert -quality %d %s %s\n";
  char newsfx[]=".jpg", oldsfx[]=".ps";
  
  if(quality<0 || quality>100) return -1;

  newname=(char *)calloc((strlen(filename)+strlen(newsfx)+1),sizeof(char));
  strcpy(newname, filename);
  lastdot=strrchr(newname, '.');
  if(lastdot && strcmp(lastdot, oldsfx)==0) strcpy(lastdot,newsfx);
  else  strcat(newname,newsfx);

  fprintf(stderr, "converting %s to %s\n",filename,newname);
  
  cmdstr=(char *)
    calloc((strlen(cmdtmpl)+strlen(filename)+strlen(newname)+4),
	   sizeof(char));
  sprintf(cmdstr,cmdtmpl,quality,filename,newname);
  rv=system(cmdstr);
  
  free(cmdstr);
  free(newname);
  
  return rv;
} /* ps_to_jpg */
