#include <stdio.h>
#include <stdlib.h>

#include <sys/time.h>



#include "rand_mesh.h"

//----------------------------------------

  struct arg_structure {
    long mesh_size;
    unsigned int  seed_val;

  };

unsigned int get_seed() {

  struct timeval tp;
  gettimeofday(&tp, NULL);
  unsigned long ul;
  unsigned int ui;
  ul = (unsigned long) tp.tv_usec;
  ui = ul % 30000;
  return (ui);
};

arg_structure process_arguments(int argc, char * argv[]){
  arg_structure args;
  // need number of nodes to build
  if (argc < 2) {
    printf ("USAGE: %s N(mesh size)\n", argv[0]);
    exit(0);
  }
  args.mesh_size = (long)atoi(argv[1]);
  // printf("Running with mesh_size %ld \n", args.mesh_size);
  args.seed_val = get_seed();
  srandom(args.seed_val);
  return args;
};

int main (int argc, char * argv[])
{
  arg_structure args;
  args = process_arguments(argc, argv);

  tmesh_class mesh;
  mesh = random_mesh(args.mesh_size);
  mesh.output_text();

  return 0;
}
