/* sa_main.c = main file for the standalone version of "CirclePack" */

#include "sa_head.h"

int sa_main(int argc,char *argv[]) 
// int _tmain(int argc, _TCHAR* argv[])
{
	int i,j,k;
	int tmp_fd,in_out_fd,disp_fd;
	char init_pack_name[NAME_MAX],hostname[NAME_MAX];
	char inmsg[BUFSIZE];

	/* set library globals */
	set_CPack_globals(); 
	
	/* seed some random values */
	set_random_seed();
	rand_next=random();
	
	init_pack_name[0]=rgb_file[0]=hostname[0]='\0';

/* Grab command line arguments. */

	msg_in_fp=bdopen(0,"r");
	msg_out_fp=disp_fp=bdopen(1,"w");

	for (i=1;i<argc;i++) {
	  if (!strcmp(argv[i],"-colorfile")) { /* file of rgb colors */
	    strncpy(rgb_file,argv[i+1],NAME_MAX);
	    i++;
	  }
	  if (!strcmp(argv[i],"-p")) { /* read and display packing */
	    strncpy(init_pack_name,argv[i+1],NAME_MAX);
	    i++;
	  }
	}

/* set up sockets for communication with GUI */

	/* in_out socket: mimicks stdin/out */

/* copyright notice */

	strncpy(CPVersion,"6.0",4); 
	sprintf(msgbuf,"CPack library started.",
		CPVersion);
	msg();

/* create principal pack and screen pointers */

	if ((packdata=(struct p_data *)
		calloc((size_t)(NUM_PACKS+1),sizeof(struct p_data)))==NULL
	    || (screendata=(struct s_data *)
		calloc((size_t)(NUM_PACKS+1),sizeof(struct s_data)))==NULL) {
	  printf("Memory allocation problems for packings.\n");
	  exit(1);
	}

/* some global variable initializations */

	log_fp=fopen("/tmp/CPack_log.txt","w");
	current_p=0;
	eucl_factor=0.5;
	inc_factor=1.0717735; /* 10th root of 2 (equates to 10%) */
	draw_speed=0;
	totalpasses=500;
	custom_fp=NULL;
	cmd_search_depth=0;
	Mob=ident_mob();
	b_flip=r_flip=NULL;
        init_shmem = 0;
	log_fp=NULL;
	strcpy(packing_dir_name,"packings/");
    home_dir = (char *) malloc(sizeof(char) * SAHOOK_MAXBUF);
    if(home_dir == NULL)  {
    	perror("malloc");
        exit(1);
    }
	CPset_home_dir(home_dir, SAHOOK_MAXBUF);
    working_dir = (char *) malloc(sizeof(char) * SAHOOK_MAXBUF);
    if(working_dir == NULL)  {
    	perror("malloc");
        exit(1);
    }
	CPset_working_dir(working_dir, SAHOOK_MAXBUF);
	CPset_user_name(user_name, 64);

/* various default initializations */

	strcpy(packing_dir_name,"packings/"); /* directory name for
		reading and writing files; default = current */
	strcpy(ps_viewer,"ggv "); /* system call to postscript viewer */
	strcpy(print_cmd,"lpr -h "); /* set print command */
	strcpy(ps_file_name,"sel_post.ps"); /* postscript filename 
		for custom printing */
	strcpy(print_file_name,"pack_post.ps"); /* postscript filename 
		for screen printing */

/* find help/packrc; read `packrc.txt' file for user-specified quantities */

	// find_help_packrc(argv[0]);  FA

/* initialize some pack and screen data, window locations, etc. */

	for (i=0;i<NUM_PACKS;i++) {
	  packdata[i].sizelimit=5000;
	  packdata[i].screen=screendata+i;
	  alloc_edge_pair(&packdata[i]);
	  live_face[i]=live_node[i]=1;
	  
	  screendata[i].box=std_real_box; 
	  screendata[i].pix_box.lx=screendata[i].pix_box.ly=0;
	  screendata[i].pix_box.rx=screendata[i].pix_box.ry=CANV_SIZE;
	  
	  screendata[i].factor=1.0;
	  /* set default view matrix; inverse is transpose. */
	  for (k=0;k<3;k++) {
	    for (j=0;j<3;j++) screendata[i].disp_trans[k][j]=0.0;
	    screendata[i].disp_trans[k][k]=1.0;
	  }
	  screendata[i].coord_flag=0;
	  screendata[i].cflag_opt=1;
	  screendata[i].fflag_opt=0;
	  screendata[i].ms_flag=0;
	}
	for (i=0;i<NUM_PACKS;i++) 
	  if (!alloc_pack_space(&packdata[i],5000,0))
	    { perror("Memory allocation problems.\n");exit(1);}

	if (strlen(init_pack_name)) {
	  sprintf(buf,"read %s",init_pack_name);
	  handle_cmd(buf,&current_p);	
	}
	   
} /* main */


