#include "sa_types.h"
#include "sa_proto.h"
#include "sa_hooks.h"

int CPset_home_dir(char *home_dir_parm, int len)
{
    return CPset_working_dir(home_dir_parm, len);
} /* CPset_home_dir */

int CPset_working_dir(char *working_dir_parm, int len)
{
    getcwd(working_dir_parm, len);
    return 0;
} /* CPset_working_dir */

int CPset_user_name(char *user_name_parm, int len)
{
    strncpy(user_name_parm, "CirclePack", len - 1);
    user_name_parm[len - 1] = '\0';
    return 0;
} /* CPset_user_name */

#ifndef WIN32
#define Sleep(t) usleep(t)
#endif

int timedelay(double tm)
     /* time delay about tm seconds. */
{
    Sleep((int) (tm * 1000));
    return 1;
} /* timedelay */

long get_time()
{
    /* CHANGEME!  This needs to return the CPU user time at some point */
    return time(NULL);
} /* get_time */

/*
 * This version of acosh takes x >= 1 and returns the branch of acosh(x)
 * satisfying acosh(x) >= 0
 */

double acosh(double x)
{
    return log(x+sqrt(x*x-1));
} /* acosh */

int isinf(double x)
{
    return(!isnan(x) && isnan(x * 0.0));
} /* isinf */

int CPget_max_open_files()
{
    int max;

    max = INTERNAL_MAX_NOFILES;
    if(FOPEN_MAX > max)  max = FOPEN_MAX;
    if(SYS_OPEN > max)  max = SYS_OPEN;

    return max;
} /* CPget_max_open_files */
