#include "sa_types.h"
#include "sa_proto.h"

/* To be called by stand-alone programs that need to use the
circle packing library routines. Not all these are needed by all
the routines. See sa_types.h for descriptions 

   The main user program must have the declaration "char *emsgbuf,*msgbuf;"
must define "Mobius Mob;"; must provide emsg(), msg(), and often needs 
routines repack_activity_msg() and refresh_canvas(). 

   Use "shell_main.c" to get stared. */

extern char *emsgbuf,*msgbuf;
extern Mobius Mob;
#ifdef WIN32
// FA
// 
// 
// double toler;
// double okerr;
// double m_toler;
// double degPI;
// int iterates;
// int **face_org;
// int pathlength;
// struct Pathlist *pathlist,*newpath;
// double layout_th;
// int line_thick;
// double ps_linewidth;
// double graylevel;
// int fill_mode;
// Box std_real_box;
//int iterates;
//extern unsigned long int rand_next;
//int num_plot;

//struct Vertlist *Vlist;
//struct Vertlist *Flist;
//struct Edgelist *Elist;
//struct Edgelist *Vertex_map;
//struct Centlist *Clist;

//unsigned long fgcolor,bgcolor;
//int sc_print_size;
//int color_ramp_size;
//unsigned char red[NUM_COLORS+1],green[NUM_COLORS+1],blue[NUM_COLORS+1];
//int bc_min,bc_max;
//int bc_offset;
// end FA
#endif

int set_CPack_globals()
{
  toler=pow(10.0, -MAX_ACCUR+5);
  okerr=pow(10.0, -MAX_ACCUR+3);
  m_toler=EpsMach();
  degPI=180.0/M_PI;
  iterates=2;
  face_org=NULL;
  pathlength=0;
  pathlist=newpath=NULL;
  layout_th=0.00001; /* threshold for circle layout accuracy */
  Mob=ident_mob();
  javaMsgHook=0;
  
  /* postscript/drawing parameters */
  num_plot=64;  /* only affects spherical drawing */
  line_thick=1;      /* 'brush' setting */
  ps_linewidth=PS_UNIT_LINEWIDTH;  /* postscript linewidth */
  graylevel=.5;      /* for postscript filling */
  fill_mode=0;       /* default gray filling */
  std_real_box.lx=std_real_box.ly=-1.1;
  std_real_box.rx=std_real_box.ry=1.1;

  /* create space for global pointers */
  Vlist=Flist=(struct Vertlist *)NULL;
  Elist=Vertex_map=(struct Edgelist *)NULL;
  Clist=(struct Centlist *)NULL;

  /* standard message space (dual use, buffers overlap). */
  emsgbuf=(char *)calloc(BUFSIZE+11,sizeof(char));
  strncpy(emsgbuf,"**ERROR** ",13); 
  msgbuf=emsgbuf+10;

  /* color and color ramp stuff */
  bc_min=255;
  bc_max=bc_offset=0;
  sc_print_size=7;
  color_ramp_size=COLOR_RAMP; /* 200 is set in sa_types.h */
  blue_to_red_ramp(0); /* default color ramp and misc colors */
  fgcolor=0;
  bgcolor=1677725; /* based on XView CMS_BACKGROUND_PIXEL */

  return 1;
} /* set_CPack_globals */









