#include "sa_types.h"
#include "sa_proto.h"

/* set radii for verts of string  */

int set_radii(struct p_data *p,double rad,char *datastr)
{
  int count=0,hits;
  double orad;
  char *endptr;
  struct Vertlist *vertlist,*trace;
  struct R_data *pR_ptr=p->packR_ptr;
	
  orad=rad;
  if ( (vertlist=Node_link_parse(p,datastr,&endptr,&hits,
		 &Vlist,&Elist,&Flist,&region,pathlist,pathlength)) != NULL)
    {
      trace=vertlist;
      if (p->hes<0) // hyp
	{ 
	  if (rad>0) { /* convert to x_radius; if small, use taylor approx.*/
	    if (rad>.0001) rad=1-exp(-2.0*rad);
	    else rad=2.0*rad*(1.0-rad*(1.0-2.0*rad/3.0));
	  }
	  do {
	    count += h_changerad(p,trace->v,rad);
	    trace=trace->next;
	  } while (trace!=NULL);
	}
      else if (p->hes==0) // eucl
	{
	  do {
	    count += e_changerad(p,trace->v,rad);
	    trace=trace->next;
	  } while (trace!=NULL);
	}
      else if (p->hes>0) // sph
	{
	  do {
	  	double mx=M_PI-toler;
	    if (rad>mx) rad=mx;
	    pR_ptr[trace->v].rad= rad;
	    trace=trace->next;
	    count++;
	  } while (trace!=NULL);
	}
      vert_free(&vertlist);
    }
  if (count)
    {
      fillcurves(p);
      sprintf(msgbuf,"Set %d radii of pack to %f.",
	      count,(singledouble)orad);
      msg();
      return count;
    }
  strcpy(msgbuf,"No radii adjusted.");
  emsg();
  return 0;
} /* set_radii */
