#include "sa_head.h"
#include "Interface.h"

/* Boundary radii of p1 are set using boundary radii of p0
multiplied by values from function specified in the Java
interface "Function" panel.
  Return 0 on error. */

int set_ratio(struct p_data *p0,struct p_data *p1)
{
  int count,v;
  double rad;
  complex ctr;
  struct R_data *p0R,*p1R;
  struct Vertlist *blist=NULL,*trace;
  char *endptr;
  char *tmp;

  tmp=(char *)calloc(4,sizeof(char));
  strcpy(tmp,"b");
  blist=node_link_parse(p0,tmp,&endptr,&count);
  if (!p0->status || !p1->status || p0->nodecount!=p1->nodecount
      || p0->hes>0 || p1->hes!=0 || !blist) {
//      	sprintf(msgbuf,"stuff: %d, %d, %d, %d, %d, %d, blist %d",p0->status,
//      	p1->status,p0->nodecount,p1->nodecount,p0->hes,p1->hes,(int)blist);
//      	debugmsg();
    sprintf(msgbuf,"usage set_ratio: check conditions on packings.");
    emsg();
    return 0;
  }
  p0R=p0->packR_ptr;
  p1R=p1->packR_ptr;
  trace=blist;
  count=0;
  while (trace) {
    v=trace->v;
    if (p0->hes<0) h_to_e_data(p0R[v].center,p0R[v].rad,&ctr,&rad);
    else {
    	rad=p0R[v].rad;
    	ctr=p0R[v].center;
    }
    p1R[v].rad=cAbs(gogetFtnValue(ctr))*rad;
    count++;
    trace=trace->next;
  }
  vert_free(&blist);
  return count;
} /* set_ratio */

