#include "sa_types.h"
#include "sa_proto.h"

/* "Square grid" packings typically have (interior) vertices 
   of degrees 4 and 8, and the "ball bearings", those of 
   degree 4, have overlaps of angle pi/2 with their neighbors.
   This command simply sets pi/2 overlaps for all interior circles
   of degree 4 (whether packing has square grid combinatorics or not). */

int sq_grid_overlaps(struct p_data *p)
{
  int i,j,count=0,setflag=0;

  if (!p->status) return count;
  if (!p->overlap_status) {
    alloc_overlaps(p);
    setflag=1;
  }
  for (i=1;i<=p->nodecount;i++) {
    if (!p->packK_ptr[i].bdry_flag && p->packK_ptr[i].num==4) {
      for (j=0;j<4;j++) if (set_single_overlap(p,i,j,cos(M_PI_2))) count++;
    }
  }
  if (!count && setflag) free_overlaps(p);
  return count;
} /* sq_grid_overlaps */




