#include "sa_types.h"
#include "sa_proto.h"

/* For euclidean packings only. Scale packing up or down so it just
fits in the square having corners (-1,-1), (1,1).*/

int square_fit(struct p_data *p)
{
  int i;
  double maxdist=0.0,re,im;
  struct K_data *pK_ptr=p->packK_ptr;
  struct R_data *pR_ptr=p->packR_ptr;

  if (!p->status || p->hes) {
    sprintf(msgbuf,"square_fit: packing must be euclidean");
    emsg();
    return 0;
  }
  for (i=1;i<=p->nodecount;i++)
    if (pK_ptr[i].bdry_flag)
      {
	re=fabs(pR_ptr[i].center.re)+pR_ptr[i].rad;
	im=fabs(pR_ptr[i].center.im)+pR_ptr[i].rad;
	maxdist = (re>maxdist) ? re : maxdist;
	maxdist = (im>maxdist) ? im : maxdist;
      }
  if (maxdist>0.0) eucl_scale(p,1/maxdist);
  return 1; 
} /* square_fit */
